Attribute VB_Name = "Subclass"
Option Explicit

Private Const WM_INITMENUPOPUP = &H117

Private Const GWL_WNDPROC& = (-4)

Private mlOldhWndProc             As Long
Private mlNewhWndProc             As Long

Private Declare Function SetWindowAsLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

Public Sub HookWindow(hwnd&)
' Install our message Handler
  If Not hwnd = 0 Then
    If Not mlOldhWndProc = 0 Then UnHookWindow
    mlNewhWndProc = hwnd
    mlOldhWndProc = SetWindowAsLong(mlNewhWndProc, GWL_WNDPROC, AddressOf WndProc)
  End If
End Sub


Public Sub UnHookWindow()
' Restore Old Handler
  If Not mlNewhWndProc = 0 Then
    Call SetWindowAsLong(mlNewhWndProc, GWL_WNDPROC, mlOldhWndProc)
    mlOldhWndProc = 0
    mlNewhWndProc = 0
  End If
End Sub


Private Function WndProc(ByVal hwnd As Long, _
                         ByVal lMsg As Long, _
                         ByVal wParam As Long, _
                         ByVal lParam As Long) As Long
On Error Resume Next
'Debug.Print lMsg
  If lMsg = WM_INITMENUPOPUP Then
    'Update Menu text if index=2 (Window List Menu)
    If (lParam And &HFFFF&) = 2 Then
      FMain.BuildMenu
    End If
  Else
    WndProc = CallWindowProc(mlOldhWndProc, hwnd, lMsg, wParam, lParam)
  End If
End Function


